/* Ce script permet de causer la mort du personnage lorsqu’il touche un objet “mortel”. 
Lorsqu’un objet mortel est touché alors :
	•il devient invisible;
	•s'il possède un son alors le son joue;
	•s'il possède des enfants alors ils s'activent (exemple: des particules);
	•Le personnage ne peut plus bouger et il devient invisible;
	•s’il possède un son ou une animation alors ils jouent
	•s'il y a une caméra alors elle s'active temporairement. 
	•La scène recommence.
*/

var ObjetsMortels: GameObject[];
var ActiverObjets: GameObject[];
var MasquerObjets: GameObject[];
var ActiverCamera: GameObject;

var DureeCamera: int = 5;

private
var PersonnageTouche = false;

function OnControllerColliderHit(hit: ControllerColliderHit) {
	if (ObjetsMortels.Length > 0) {
		// ramasser les objets
		for (var objet in ObjetsMortels)
		if (objet != null) {
			if (hit.collider.name == objet.name) {
				objet.renderer.enabled = false;
				objet.collider.enabled = false;

				//rend les enfants invisibles, 
				var renderDesEnfants = objet.GetComponentsInChildren(Renderer);
				for (var enfant: Renderer in renderDesEnfants) {
					enfant.renderer.enabled = false;
				}

				objet.SetActiveRecursively(true);

				if (objet.GetComponent("AudioSource")) objet.audio.Play();

				//mort du personnage 
				var scriptDeplacement = gameObject.GetComponent(AnimationPersonnage);
				if (scriptDeplacement != null) scriptDeplacement.enabled = false;
				if (GetComponent("AudioSource")) audio.Play();
				PersonnageTouche = true;
				if (GetComponent("Animation")) {
					animation.Play();
					animation.wrapMode = WrapMode.Once;
					animation.Play();
				}

				//on peut activer la camera si on a trouvé le dernier objet
				if (ActiverCamera != null) {
					var cameraPersonnage = Camera.main.gameObject;
					Camera.main.gameObject.active = false;
					ActiverCamera.active = true;
					yield WaitForSeconds(DureeCamera);
					cameraPersonnage.active = true;
					ActiverCamera.active = false;
				}

				for (var objet in ActiverObjets)
				if (objet != null) {
					objet.SetActiveRecursively(true);
					if (objet.GetComponent("Animation")) objet.animation.Play();
					if (objet.GetComponent("AudioSource")) objet.audio.Play();
				}

				for (var objet in MasquerObjets)
				if (objet != null) {
					objet.SetActiveRecursively(false);
				}
			}
		} else print("Des objets vides doivent être trouvés dans les paramètres de l'inspecteur!!!!");

	} else print("Il faut identifier les objets dans l'inspecteur");
}

function Update() {
	if (PersonnageTouche) {
		var renderDesEnfants = gameObject.GetComponentsInChildren(Renderer);
		for (var enfant: Renderer in renderDesEnfants) {
			enfant.renderer.material.shader = Shader.Find("Transparent/Diffuse");
			enfant.renderer.material.color.g -= .01;
			enfant.renderer.material.color.b -= .01;
			enfant.renderer.material.color.a -= .01;
			if (enfant.renderer.material.color.a < .02) Application.LoadLevel(0);
		}
	}
}